/* This script finds geometric successors to a polyline
 * It requires a polyline layer with geometrically connected
 * polylines, and one polyline selected.
 * Copyright (c) Niklas Lindquist 2007
 */
function getGeometricSuccessors(polylineLayer, polylineShape)
{
	var candidates = polylineLayer.getIntersectingShapes(polylineShape);
	if (candidates == null)
		return;
	
	var successors = new Array();

	var endPoint = polylineShape.getCoord(0, polylineShape.getCoordCount(0)-1);

	var write = 0;
	for (var i = 0; i < candidates.length; ++i)
	{
		var shp = candidates[i];

		if (endPoint.isEqual(shp.getCoord(0, 0)))
		{
			successors[write++] = shp;
		}
	}
	
	return successors;
}

function testme()
{
	var lyr = workspace.browseLayer("Polyline Layer");
	if (lyr == null)
		return;
	if (lyr.selectionCount != 1)
	{
		alert('Select one (1) polyline to find successors for\nand try again.');
		return;
	}

	var shp = lyr.getSelectedShape(0);

	var successors = getGeometricSuccessors(lyr, shp);
	if (successors == null)
	{
		alert('No successors found.');
		return;
	}
	
	alert('' + successors.length + ' successors found.');
	for (var i = 0; i < successors.length; ++i)
	{
		successors[i].selected = true;
	}
	
	workspace.refresh();
}

testme();
